#!/usr/bin/python

import sys
import subprocess
import re
import time

def getUsers():
    proc = subprocess.Popen(["momctl", "-q", "users"], stdout=subprocess.PIPE)
    users = []
    us = proc.stdout.readlines()[0].split()[-1][:-1].split(',')
    for u in us:
        users.append(u)
    return users

def getProcesses(activeu, on_off):
    pbs_mom = False
    i = 0
    proc = subprocess.Popen(["ps", "fax", "-eo" "user:20,stat,pid,command"], stdout=subprocess.PIPE)
    for line in proc.stdout.readlines():
        splitted = line.split()
        if splitted[1] == 'D':
            jn = ' '.join(splitted[5:])
            ti = subprocess.Popen(["ps", "-o", "start", "-p", splitted[2]], stdout=subprocess.PIPE)
            for l in ti.stdout.readlines():
                continue
            if splitted[0] == "root" or splitted[0] not in activeu:
                print("Found process with D state from inactive user or root in ps fax on line " + str(i) + " :\n" + line)
                if re.search('\_ sync', line):
                    if on_off == "on":
                        subprocess.call(["iptables", "-I", "OUTPUT", "-p", "tcp", "--dport", "2049", "-j", "REJECT"])
                        time.sleep(600)
                        subprocess.call(["iptables", "-D", "OUTPUT", "-p", "tcp", "--dport", "2049", "-j", "REJECT"])
                        break
        i += 1


if __name__ == "__main__":
    iptables_on_off = sys.argv[1]
    users = getUsers()
    getProcesses(users, iptables_on_off)
